# Theme Test

__Theme Test__ provides development tools for themers, such as [the HTML/CSS pattern library](#pattern-library) and [the theme comparison console](#themeview-console).

## Pattern library

This extension provides a page (**Support » Developer » Theme Test**) that demos various markup types in use in CiviCRM core. By standardisiing certain markup patterns *theming* will become a lot more achievable.

![Screenshot](/themetest.jpg)

It currently includes lots of samples that we don't want to repeat, but are in actual use. Nb. this extension is for developers working on themes or exploring CiviCRM's user interface.

History: It began life as part of [Artul Robot's Aah theme](https://codeberg.org/artfulrobot/aaah) but a community discussion on theming suggested it should be its own extension. It is being maintained by Rich Lott (@artfulrobot) & Nicol Wistreich (@nicol).

The extension is licensed under [AGPL-3.0](LICENSE.txt).

### Adding patterns

To add a pattern you'll need to edit the `snippets.json` file and provide an HTML file in `ang/themetest/snippets/yourFile.html`. Please be mindful that the files are numbered sequentially in the form `{category-name}number` ie dropdown1.html.

The snippets.json file is an array with entries like this:

```json
{
  "category": "Buttons",
  "name": "button1",
  "title": "Without .btn",
  "status": "recommended",
  "canonical": true,
  "description": "Optional text description"
}
```

- `category` just helps group the snippets. You can omit it ("Other" is then used)
- `name` is used to construct the filename, so in the example above, it would be `yourFile`
- `title` is displayed on screen
- `status` is either **recommended** (best practice), **supported** (themes can handle _for now_), **deprecated** (do not use), **unspecified** (awaiting categorisation), and prototype (describes a future recommended pattern that's not fully supported in CiviCRM core yet). If not completed the UI displays undefined.
- `canonical` Optional. If `true` then we consider this a supported markup pattern. This means you should use this pattern in your markup, and themes should support it. If ommitted or not true, then it's just some real world core markup that ought to be one day standardised!
- `description` Optional.

## Themeview console

The "Themeview (TV) console" allows you compare the visual appearance of different themes. Use it to check your theme against a benchmark (like Greenwich) -- or to QA subtle
changes in shared files (such as RiverLea core). Here's how to use it:

* Enable the extension
* Navigate to any page (for example: `/civicrm/contact/view?reset=1&cid=201`)
* Edit the URL to include `_tv` (for example: `/civicrm/_tv/contact/view?reset=1&cid=201`)
* It will display [a control panel and several IFRAMEs](images/console.png).

For a quick demonstration of the console, see [the one minute demo video](https://storage.googleapis.com/civicrm/video/themeview-demo.mov).
