(function(angular, $, _) {

  // Here is where you declare your snippets.
  const snippets = [
    'button1',
    'button2',
  ];

  angular.module('themetest').config(function($routeProvider) {
    $routeProvider.when('/themetest', {
      controller: 'Themetestbrowse',
      controllerAs: '$ctrl',
      templateUrl: '~/themetest/browse.html',

      // If you need to look up data when opening the page, list it out
      // under "resolve".
      resolve: {}
    });
  }
  );

  // The controller uses *injection*. This default injects a few things:
  //   $scope -- This is the set of variables shared between JS and HTML.
  //   crmApi, crmStatus, crmUiHelp -- These are services provided by civicrm-core.
  //   myContact -- The current contact, defined above in config().
  const browseController = angular.module('themetest').controller('Themetestbrowse', function($scope, crmApi4, crmStatus, crmUiHelp, $http, dialogService) {
    // The ts() and hs() functions help load strings for this module.
    var ts = $scope.ts = CRM.ts('themetest');
    var hs = $scope.hs = crmUiHelp({ file: 'CRM/themetest/browse' }); // See: templates/CRM/themetest/browse.hlp
    // Local variable for this controller (needed when inside a callback fn where `this` is not available).
    var ctrl = this;

    let snippetHtml = {};

    $scope.$on('$includeContentLoaded', (e, url) => {
      let snippetNameLoaded = url.replace(/~\/themetest\/snippets\/(.*)\.html/, '$1');
      console.log("SNIPPET LOADED:", { url, snippetNameLoaded });
      let snippetLoaded = this.snippets.find(snippet => snippet.name === snippetNameLoaded);
    });
    this.lo = function(a, b, c) { console.log("onload:", a, b, c); };

    this.snippets = [];
    this.snippetsToShow = [];
    this.selectedCategory = '';
    this.categoriesList = [];
    this.snippetIndex = {};
    this.snippetsShown = [];
    this.styleGuideMode = false;

    this.updateSnippetsList = () => {
      if (!this.selectedCategory) {
        this.snippetsToShow = [];
      }
      else {
        this.snippetsToShow = this.snippetIndex[this.selectedCategory]
          .filter(snippet => this.styleGuideMode ? snippet.canonical : true);
      }
    };

    this.showCategory = category => {
      this.selectedCategory = category;
      localStorage.setItem('category', category);
      this.updateSnippetsList();
      let snippetsContainer = document.querySelector('.theme-test-snippets');
      // console.log("showCategory", category, this.snippetsToShow);
      if (snippetsContainer) {
        window.scrollTo({
          top: snippetsContainer.getBoundingClientRect().top - document.body.getBoundingClientRect().top - 60,
          behavior: 'smooth'
        });
      }
    };

    $http({
      method: 'GET',
      // Always reload the snippets json, bust any cache.
      url: CRM.url('civicrm/themetest/asset?need=snippets&nocache=' + (new Date()).getTime()),
    }).then(r => {
      this.snippets = r.data;
      console.log("Snippets loaded", r.data);
      this.snippets.forEach(snippet => {
        let category = snippet.category || 'Other';
        if (!(category in this.snippetIndex)) {
          this.snippetIndex[category] = [];
          this.categoriesList.push(category)
        }
        this.snippetIndex[category].push(snippet);

        // Load the raw HTML of this snippet.
        $http({ method: 'GET', url: `${CRM.resourceUrls.themetest}/ang/themetest/snippets/${snippet.name}.html` })
          .then(snippetResponse => { snippet.html = snippetResponse.data; });

      });
      this.categoriesList = this.categoriesList.sort();
      console.log({ list: this.categoriesList, snippetIndex: this.snippetIndex });
      // re-select the previously selected category to speed up reloading page.
      if (localStorage.getItem('category')) {
        this.showCategory(localStorage.getItem('category'));
      }


      // this.snippets.forEach(snippet => {
      //   $http({method:'GET', url: `${CRM.resourceUrls.themetest}/ang/themetest/snippets/${snippet.name}.html`})
      //   .then(snippetResponse => {
      //       snippet.html = snippetResponse.data;
      //     });
      // });
    });

    // this.save = function() {
    //   return crmStatus(
    //     // Status messages. For defaults, just use "{}"
    //     {start: ts('Saving...'), success: ts('Saved')},
    //     // The save action. Note that crmApi() returns a promise.
    //     crmApi('Contact', 'create', {
    //       id: ctrl.myContact.id,
    //       first_name: ctrl.myContact.first_name,
    //       last_name: ctrl.myContact.last_name
    //     })
    //   );
    // };

    // Some angular snippets require data models and bits.

    $scope.dialog1msg = '(you have not opened it yet)';
    $scope.dialog1open = (e) => {
      console.log("dialog1open");
      e.stopPropagation();
      e.preventDefault();
      $scope.dialog1msg = 'dialog should be showing';
      dialogService.open('dialog1', '~/themetest/snippets/dialog1content.html', $scope.dialog1model, {})
        .then(function(result) {
          console.log('received output from dialog', result);
          $scope.dialog1msg = 'you have opened and closed it';
        })
        .catch(function(e, r) {
          console.log({ e, r });
          $scope.dialog1msg = 'you have opened and cancelled it';
        })
    };
  });


  snippets.forEach(snippetName => {
    console.log(`declaring directive themetest${snippetName}`);
    browseController.directive(`themetest${snippetName}`, () => ({
      restrict: 'C',
      templateUrl: `~/themetest/snippets/${snippetName}`,
      replace: true
    }));
  });

})(angular, CRM.$, CRM._);
