<!DOCTYPE html>
<html>
<head>
  <title>{$pageTitle|strip_tags|escape}</title>
  {foreach from=$scripts item=script}
    <script type="text/javascript" src="{$script|escape}"></script>
  {/foreach}
  {foreach from=$styles item=style}
    <link rel="stylesheet" type="text/css" href="{$style|escape}" />
  {/foreach}
  <script type="text/javascript">
    window.tvData = {$tvData|@json_encode};
  </script>
</head>
<body>

<h1>{$pageTitle|escape}</h1>

<tv-main></tv-main>

{literal}
<template id="tv-main">
  <div class="control-panel">
    <form>
      <select ng-model="iframeSpec.mode">
        <option ng-repeat="(modeName, mode) in modes" value="{{modeName}}">{{mode.title}}</option>
      </select>

      <label>
        Width: <input class="cfg-width" type="text" ng-model="iframeSpec.width">
      </label>
      <label>
        Height: <input class="cfg-height" type="text" ng-model="iframeSpec.height">
      </label>

      <label ng-repeat="theme in themes">
        <input type="checkbox" ng-model="theme.active" ng-change="onToggleTheme(theme)">
        {{theme.name}}
      </label>

      <p class="tip"><strong>TIP</strong>: Scroll in the first pane, and the rest will follow.</p>

    </form>
  </div>
  <div class="container"></div>
</template>
{/literal}

<script type="text/javascript">
  angular.bootstrap($('body'), ['themeview']);
</script>

</body>
</html>
