<?php

require_once 'themetest.civix.php';
// phpcs:disable
use CRM_Themetest_ExtensionUtil as E;
// phpcs:enable

/**
 * Implements hook_civicrm_config().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_config/
 */
function themetest_civicrm_config(&$config) {
  _themetest_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_install
 */
function themetest_civicrm_install() {
  _themetest_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_enable
 */
function themetest_civicrm_enable() {
  _themetest_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_navigationMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_navigationMenu
 */
function themetest_civicrm_navigationMenu(&$menu) {
  _themetest_civix_insert_navigation_menu($menu, 'Support/Developer', [
    'label' => E::ts('Theme Test'),
    'name' => 'themetest',
    'url' => 'civicrm/a/#/themetest',
    'permission' => 'administer CiviCRM',
    'operator' => 'OR',
    'separator' => 0,
  ]);
  _themetest_civix_navigationMenu($menu);
}
